From 150f2d75313a7cd262e099cb75b24510ca588f44 Mon Sep 17 00:00:00 2001
From: amit <amitlangote09@gmail.com>
Date: Fri, 17 Nov 2017 14:00:42 +0900
Subject: [PATCH 1/2] Add default partition case in inheritance testing

---
 src/test/regress/expected/inherit.out | 29 +++++++++++++++++++----------
 src/test/regress/sql/inherit.sql      |  9 +++++----
 2 files changed, 24 insertions(+), 14 deletions(-)

diff --git a/src/test/regress/expected/inherit.out b/src/test/regress/expected/inherit.out
index c698faff2f..a202caeb25 100644
--- a/src/test/regress/expected/inherit.out
+++ b/src/test/regress/expected/inherit.out
@@ -1853,13 +1853,14 @@ drop table range_list_parted;
 -- check that constraint exclusion is able to cope with the partition
 -- constraint emitted for multi-column range partitioned tables
 create table mcrparted (a int, b int, c int) partition by range (a, abs(b), c);
+create table mcrparted_def partition of mcrparted default;
 create table mcrparted0 partition of mcrparted for values from (minvalue, minvalue, minvalue) to (1, 1, 1);
 create table mcrparted1 partition of mcrparted for values from (1, 1, 1) to (10, 5, 10);
 create table mcrparted2 partition of mcrparted for values from (10, 5, 10) to (10, 10, 10);
 create table mcrparted3 partition of mcrparted for values from (11, 1, 1) to (20, 10, 10);
 create table mcrparted4 partition of mcrparted for values from (20, 10, 10) to (20, 20, 20);
 create table mcrparted5 partition of mcrparted for values from (20, 20, 20) to (maxvalue, maxvalue, maxvalue);
-explain (costs off) select * from mcrparted where a = 0;	-- scans mcrparted0
+explain (costs off) select * from mcrparted where a = 0;	-- scans mcrparted0, mcrparted_def
           QUERY PLAN          
 ------------------------------
  Append
@@ -1867,7 +1868,7 @@ explain (costs off) select * from mcrparted where a = 0;	-- scans mcrparted0
          Filter: (a = 0)
 (3 rows)
 
-explain (costs off) select * from mcrparted where a = 10 and abs(b) < 5;	-- scans mcrparted1
+explain (costs off) select * from mcrparted where a = 10 and abs(b) < 5;	-- scans mcrparted1, mcrparted_def
                  QUERY PLAN                  
 ---------------------------------------------
  Append
@@ -1875,7 +1876,7 @@ explain (costs off) select * from mcrparted where a = 10 and abs(b) < 5;	-- scan
          Filter: ((a = 10) AND (abs(b) < 5))
 (3 rows)
 
-explain (costs off) select * from mcrparted where a = 10 and abs(b) = 5;	-- scans mcrparted1, mcrparted2
+explain (costs off) select * from mcrparted where a = 10 and abs(b) = 5;	-- scans mcrparted1, mcrparted2, mcrparted_def
                  QUERY PLAN                  
 ---------------------------------------------
  Append
@@ -1883,11 +1884,13 @@ explain (costs off) select * from mcrparted where a = 10 and abs(b) = 5;	-- scan
          Filter: ((a = 10) AND (abs(b) = 5))
    ->  Seq Scan on mcrparted2
          Filter: ((a = 10) AND (abs(b) = 5))
-(5 rows)
+   ->  Seq Scan on mcrparted_def
+         Filter: ((a = 10) AND (abs(b) = 5))
+(7 rows)
 
 explain (costs off) select * from mcrparted where abs(b) = 5;	-- scans all partitions
-          QUERY PLAN          
-------------------------------
+           QUERY PLAN            
+---------------------------------
  Append
    ->  Seq Scan on mcrparted0
          Filter: (abs(b) = 5)
@@ -1899,7 +1902,9 @@ explain (costs off) select * from mcrparted where abs(b) = 5;	-- scans all parti
          Filter: (abs(b) = 5)
    ->  Seq Scan on mcrparted5
          Filter: (abs(b) = 5)
-(11 rows)
+   ->  Seq Scan on mcrparted_def
+         Filter: (abs(b) = 5)
+(13 rows)
 
 explain (costs off) select * from mcrparted where a > -1;	-- scans all partitions
              QUERY PLAN              
@@ -1917,7 +1922,9 @@ explain (costs off) select * from mcrparted where a > -1;	-- scans all partition
          Filter: (a > '-1'::integer)
    ->  Seq Scan on mcrparted5
          Filter: (a > '-1'::integer)
-(13 rows)
+   ->  Seq Scan on mcrparted_def
+         Filter: (a > '-1'::integer)
+(15 rows)
 
 explain (costs off) select * from mcrparted where a = 20 and abs(b) = 10 and c > 10;	-- scans mcrparted4
                         QUERY PLAN                         
@@ -1927,7 +1934,7 @@ explain (costs off) select * from mcrparted where a = 20 and abs(b) = 10 and c >
          Filter: ((c > 10) AND (a = 20) AND (abs(b) = 10))
 (3 rows)
 
-explain (costs off) select * from mcrparted where a = 20 and c > 20; -- scans mcrparted3, mcrparte4, mcrparte5
+explain (costs off) select * from mcrparted where a = 20 and c > 20; -- scans mcrparted3, mcrparte4, mcrparte5, mcrparted_def
                QUERY PLAN                
 -----------------------------------------
  Append
@@ -1937,7 +1944,9 @@ explain (costs off) select * from mcrparted where a = 20 and c > 20; -- scans mc
          Filter: ((c > 20) AND (a = 20))
    ->  Seq Scan on mcrparted5
          Filter: ((c > 20) AND (a = 20))
-(7 rows)
+   ->  Seq Scan on mcrparted_def
+         Filter: ((c > 20) AND (a = 20))
+(9 rows)
 
 drop table mcrparted;
 -- check that partitioned table Appends cope with being referenced in
diff --git a/src/test/regress/sql/inherit.sql b/src/test/regress/sql/inherit.sql
index 169d0dc0f5..c71febffc2 100644
--- a/src/test/regress/sql/inherit.sql
+++ b/src/test/regress/sql/inherit.sql
@@ -664,19 +664,20 @@ drop table range_list_parted;
 -- check that constraint exclusion is able to cope with the partition
 -- constraint emitted for multi-column range partitioned tables
 create table mcrparted (a int, b int, c int) partition by range (a, abs(b), c);
+create table mcrparted_def partition of mcrparted default;
 create table mcrparted0 partition of mcrparted for values from (minvalue, minvalue, minvalue) to (1, 1, 1);
 create table mcrparted1 partition of mcrparted for values from (1, 1, 1) to (10, 5, 10);
 create table mcrparted2 partition of mcrparted for values from (10, 5, 10) to (10, 10, 10);
 create table mcrparted3 partition of mcrparted for values from (11, 1, 1) to (20, 10, 10);
 create table mcrparted4 partition of mcrparted for values from (20, 10, 10) to (20, 20, 20);
 create table mcrparted5 partition of mcrparted for values from (20, 20, 20) to (maxvalue, maxvalue, maxvalue);
-explain (costs off) select * from mcrparted where a = 0;	-- scans mcrparted0
-explain (costs off) select * from mcrparted where a = 10 and abs(b) < 5;	-- scans mcrparted1
-explain (costs off) select * from mcrparted where a = 10 and abs(b) = 5;	-- scans mcrparted1, mcrparted2
+explain (costs off) select * from mcrparted where a = 0;	-- scans mcrparted0, mcrparted_def
+explain (costs off) select * from mcrparted where a = 10 and abs(b) < 5;	-- scans mcrparted1, mcrparted_def
+explain (costs off) select * from mcrparted where a = 10 and abs(b) = 5;	-- scans mcrparted1, mcrparted2, mcrparted_def
 explain (costs off) select * from mcrparted where abs(b) = 5;	-- scans all partitions
 explain (costs off) select * from mcrparted where a > -1;	-- scans all partitions
 explain (costs off) select * from mcrparted where a = 20 and abs(b) = 10 and c > 10;	-- scans mcrparted4
-explain (costs off) select * from mcrparted where a = 20 and c > 20; -- scans mcrparted3, mcrparte4, mcrparte5
+explain (costs off) select * from mcrparted where a = 20 and c > 20; -- scans mcrparted3, mcrparte4, mcrparte5, mcrparted_def
 drop table mcrparted;
 
 -- check that partitioned table Appends cope with being referenced in
-- 
2.11.0

